commit 83ab415333d8e09bc75fc2c14fc9772131bd3e86
Author: freddy77 <freddy77>
Date:   Mon Sep 8 19:22:44 2008 +0000

    more fixes for utf8 and odbc

diff --git a/ChangeLog b/ChangeLog
index 4790b15..2905009 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Mon Sep 08 21:21:57 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/unittests/utf8.c: test with small column sizes
+	* src/tds/query.c: fix column size preparing
+
 Mon Sep  8 13:49:19 EDT 2008	JK Lowden <jklowden@freetds.org>
 	* include/cspublic.h fix #define of BLK_VERSION_110 
 
@@ -611,4 +615,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2600 2008/09/08 17:50:25 jklowden Exp $
+$Id: ChangeLog,v 1.2601 2008/09/08 19:22:44 freddy77 Exp $
diff --git a/src/odbc/unittests/utf8.c b/src/odbc/unittests/utf8.c
index 721aabc..c353021 100755
--- a/src/odbc/unittests/utf8.c
+++ b/src/odbc/unittests/utf8.c
@@ -1,7 +1,7 @@
 #include "common.h"
 
 /* test binding with UTF-8 encoding */
-static char software_version[] = "$Id: utf8.c,v 1.3 2008/08/17 08:08:06 freddy77 Exp $";
+static char software_version[] = "$Id: utf8.c,v 1.4 2008/09/08 19:22:44 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static void init_connect(void);
@@ -70,15 +70,58 @@ static const char * const strings_hex[] = {
 	NULL, NULL
 };
 
+static char tmp[2048];
+
+static void
+TestBinding(int minimun)
+{
+	const char * const*p;
+	SQLINTEGER n;
+	SQLLEN n_len;
+
+	sprintf(tmp, "DELETE FROM %s", table_name);
+	Command(Statement, tmp);
+
+	/* insert with SQLPrepare/SQLBindParameter/SQLExecute */
+	sprintf(tmp, "INSERT INTO %s VALUES(?,?,?)", table_name);
+	CHK(SQLPrepare, (Statement, (SQLCHAR *) tmp, SQL_NTS));
+	CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_INPUT, SQL_C_LONG,
+		SQL_INTEGER, 0, 0, &n, 0, &n_len));
+	n_len = sizeof(n);
+	
+	for (n = 1, p = strings; p[0] && p[1]; p += 2, ++n) {
+		SQLLEN s1_len, s2_len;
+		int len;
+
+		len = minimun ? (strlen(strings_hex[p-strings]) - 2) /4 : 40;
+		CHK(SQLBindParameter, (Statement, 2, SQL_PARAM_INPUT, SQL_C_CHAR,
+			SQL_WCHAR, len, 0, (void *) p[0], 0, &s1_len));
+		len = minimun ? (strlen(strings_hex[p+1-strings]) - 2) /4 : 40;
+		/* FIXME this with SQL_VARCHAR produce wrong protocol data */
+		CHK(SQLBindParameter, (Statement, 3, SQL_PARAM_INPUT, SQL_C_CHAR,
+			SQL_WVARCHAR, len, 0, (void *) p[1], 0, &s2_len));
+		s1_len = strlen(p[0]);
+		s2_len = strlen(p[1]);
+		printf("insert #%d\n", (int) n);
+		CHK(SQLExecute, (Statement));
+	}
+
+	/* check rows */
+	for (n = 1, p = strings_hex; p[0] && p[1]; p += 2, ++n) {
+		sprintf(tmp, "IF NOT EXISTS(SELECT * FROM %s WHERE k = %d AND c = %s AND vc = %s) SELECT 1", table_name, (int) n, p[0], p[1]);
+		CheckNoRow(tmp);
+	}
+
+	ResetStatement();
+}
+
 int
 main(int argc, char *argv[])
 {
 	int res;
-	char tmp[2048];
 	SQLSMALLINT len;
 	const char * const*p;
 	SQLINTEGER n;
-	SQLLEN n_len;
 
 	if (read_login_info())
 		exit(1);
@@ -128,35 +171,10 @@ main(int argc, char *argv[])
 		sprintf(tmp, "IF NOT EXISTS(SELECT * FROM %s WHERE k = %d AND c = %s AND vc = %s) SELECT 1", table_name, (int) n, p[0], p[1]);
 		CheckNoRow(tmp);
 	}
-	sprintf(tmp, "DELETE FROM %s", table_name);
-	Command(Statement, tmp);
 
-	/* insert with SQLPrepare/SQLBindParameter/SQLExecute */
-	sprintf(tmp, "INSERT INTO %s VALUES(?,?,?)", table_name);
-	CHK(SQLPrepare, (Statement, (SQLCHAR *) tmp, SQL_NTS));
-	CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_INPUT, SQL_C_LONG,
-		SQL_INTEGER, 0, 0, &n, 0, &n_len));
-	n_len = sizeof(n);
-	
-	for (n = 1, p = strings; p[0] && p[1]; p += 2, ++n) {
-		SQLLEN s1_len, s2_len;
+	TestBinding(0);
 
-		CHK(SQLBindParameter, (Statement, 2, SQL_PARAM_INPUT, SQL_C_CHAR,
-			SQL_WCHAR, 40, 0, (void *) p[0], 0, &s1_len));
-		/* FIXME this with SQL_VARCHAR produce wrong protocol data */
-		CHK(SQLBindParameter, (Statement, 3, SQL_PARAM_INPUT, SQL_C_CHAR,
-			SQL_WVARCHAR, 40, 0, (void *) p[1], 0, &s2_len));
-		s1_len = strlen(p[0]);
-		s2_len = strlen(p[1]);
-		printf("insert #%d\n", (int) n);
-		CHK(SQLExecute, (Statement));
-	}
-
-	/* check rows */
-	for (n = 1, p = strings_hex; p[0] && p[1]; p += 2, ++n) {
-		sprintf(tmp, "IF NOT EXISTS(SELECT * FROM %s WHERE k = %d AND c = %s AND vc = %s) SELECT 1", table_name, (int) n, p[0], p[1]);
-		CheckNoRow(tmp);
-	}
+	TestBinding(1);
 
 	/* cleanup */
 	sprintf(tmp, "IF OBJECT_ID(N'%s') IS NOT NULL DROP TABLE %s", table_name, table_name);
diff --git a/src/tds/query.c b/src/tds/query.c
index 583ae88..b62fe5c 100644
--- a/src/tds/query.c
+++ b/src/tds/query.c
@@ -46,7 +46,7 @@
 
 #include <assert.h>
 
-TDS_RCSID(var, "$Id: query.c,v 1.226 2008/09/04 06:43:49 freddy77 Exp $");
+TDS_RCSID(var, "$Id: query.c,v 1.227 2008/09/08 19:22:44 freddy77 Exp $");
 
 static void tds_put_params(TDSSOCKET * tds, TDSPARAMINFO * info, int flags);
 static void tds7_put_query_params(TDSSOCKET * tds, const char *query, int query_len);
@@ -55,6 +55,7 @@ static int tds_put_data_info(TDSSOCKET * tds, TDSCOLUMN * curcol, int flags);
 static int tds_put_data(TDSSOCKET * tds, TDSCOLUMN * curcol);
 static char *tds7_build_param_def_from_query(TDSSOCKET * tds, const char* converted_query, int converted_query_len, TDSPARAMINFO * params, size_t *out_len);
 static char *tds7_build_param_def_from_params(TDSSOCKET * tds, const char* query, size_t query_len, TDSPARAMINFO * params, size_t *out_len);
+static int tds_fix_column_size(TDSSOCKET * tds, TDSCOLUMN * curcol);
 
 static int tds_send_emulated_execute(TDSSOCKET * tds, const char *query, TDSPARAMINFO * params);
 static const char *tds_skip_comment(const char *s);
@@ -613,10 +614,13 @@ tds_get_column_declaration(TDSSOCKET * tds, TDSCOLUMN * curcol, char *out)
 {
 	const char *fmt = NULL;
 	int max_len = IS_TDS7_PLUS(tds) ? 8000 : 255;
+	int size;
 
 	CHECK_TDS_EXTRA(tds);
 	CHECK_COLUMN_EXTRA(curcol);
 
+	size = tds_fix_column_size(tds, curcol);
+
 	switch (tds_get_conversion_type(curcol->on_server.column_type, curcol->on_server.column_size)) {
 	case XSYBCHAR:
 	case SYBCHAR:
@@ -697,12 +701,14 @@ tds_get_column_declaration(TDSSOCKET * tds, TDSCOLUMN * curcol, char *out)
 		if (IS_TDS7_PLUS(tds)) {
 			fmt = "NVARCHAR(%d)";
 			max_len = 4000;
+			size /= 2;
 		}
 		break;
 	case XSYBNCHAR:
 		if (IS_TDS7_PLUS(tds)) {
 			fmt = "NCHAR(%d)";
 			max_len = 4000;
+			size /= 2;
 		}
 		break;
 		/* nullable types should not occur here... */
@@ -723,9 +729,6 @@ tds_get_column_declaration(TDSSOCKET * tds, TDSCOLUMN * curcol, char *out)
 	}
 
 	if (fmt) {
-		TDS_INT size = curcol->on_server.column_size;
-		if (!size)
-			size = curcol->column_size;
 		/* fill out */
 		sprintf(out, fmt, size > 0 ? (size > max_len ? max_len : size) : 1);
 		return TDS_SUCCEED;

